#include <windows.h>
//////////////////////////////////////////////////////////////////////////////
// FUNCTION: RelayoutDialog
//
// PURPOSE: Re-lays out a dialog based on a dialog template.      This function
//          iterates through all the child window controls and does a SetWindowPos
//          for each.      It also does a SetWindowText for each static text control
//          and updates the selected bitmap or icon in a static image control.
//          This assumes that the current dialog and the new template have all the
//          same controls, with the same IDCs.
//
// ON ENTRY:
//           HINSTANCE hInst: the hInstance of the current module.
//           HWND hDlg: the dialog to layout.
//                LPCWSTR iddTemplate: the new template for the dialog (can use
//                the MAKEINTRESOURCE macro).
//
// ON EXIT: TRUE if success; FALSE if failure (either the iddTemplate is
//                invalid, or there are two or more IDC_STATICs in the template).
//
BOOL RelayoutDialog(HINSTANCE hInst, HWND hDlg, LPCWSTR iddTemplate);

