/*
 * We want to continue in Simon's idea "One binary rule them all" - one binary runs
 * on as many platform versions as possible, so we shouldn't depend and link against on 
 * extension not available on platforms like WinCE 4.1 which don't have aygshell's SH* 
 * functions etc. At this moment we link only against coredll.lib -- ynezz
 */
#include "wince.h"
#include "wince_aygshell.h"

#ifdef SHELL_AYGSHELL

static HMODULE aygshell_module;

#define NOTHING
#define DECL_AYGSHELL_FUNCTION(linkage, rettype, name, params) \
	typedef rettype (WINAPI *ast_##name) params; \
	linkage ast_##name as_##name
#define GET_AYGSHELL_FUNCTION(module, name) \
	as_##name = (ast_##name) GetProcAddress(module, TEXT(#name))

DECL_AYGSHELL_FUNCTION(NOTHING, BOOL, SHInitDialog, (PSHINITDLGINFO pshidi));
DECL_AYGSHELL_FUNCTION(NOTHING, BOOL, SHDoneButton, (HWND hwndRequester, DWORD dwFlags));
DECL_AYGSHELL_FUNCTION(NOTHING, BOOL, SHFullScreen, (HWND hwndRequester, DWORD dwState));
DECL_AYGSHELL_FUNCTION(NOTHING, BOOL, SHCreateMenuBar, (SHMENUBARINFO * pmb));
DECL_AYGSHELL_FUNCTION(NOTHING, HWND, SHFindMenuBar, (HWND hwnd));
DECL_AYGSHELL_FUNCTION(NOTHING, BOOL, SHInitExtraControls, (void));
DECL_AYGSHELL_FUNCTION(NOTHING, DWORD, SHRecognizeGesture, (PSHRGINFO pshrginfo));
DECL_AYGSHELL_FUNCTION(NOTHING, BOOL, SHHandleWMSettingChange, (HWND hwnd, WPARAM wParam, LPARAM lParam, SHACTIVATEINFO * psai));
DECL_AYGSHELL_FUNCTION(NOTHING, BOOL, SHHandleWMActivate, (HWND hwnd, WPARAM wParam, LPARAM lParam, SHACTIVATEINFO * psai, DWORD dwFlags));

void aygshell_init(void)
{
	debug_level((DBG_FUNCTION, "aygshell_init();\n"));
	aygshell_module = LoadLibrary(TEXT("aygshell.dll"));

	/* fatalbox for now... */
	if (!aygshell_module)
		fatalbox("Unable to load aygshell.dll");

	GET_AYGSHELL_FUNCTION(aygshell_module, SHInitDialog);
	GET_AYGSHELL_FUNCTION(aygshell_module, SHFullScreen);
	GET_AYGSHELL_FUNCTION(aygshell_module, SHDoneButton);
	GET_AYGSHELL_FUNCTION(aygshell_module, SHCreateMenuBar);
	GET_AYGSHELL_FUNCTION(aygshell_module, SHFindMenuBar);
	GET_AYGSHELL_FUNCTION(aygshell_module, SHInitExtraControls);
	GET_AYGSHELL_FUNCTION(aygshell_module, SHRecognizeGesture);
#if !(UNDER_CE < 0x400)
	/* beware, this function doesn't exists on evc4 PPC2003 emulator! */
	GET_AYGSHELL_FUNCTION(aygshell_module, SHHandleWMSettingChange);
	GET_AYGSHELL_FUNCTION(aygshell_module, SHHandleWMActivate);
#endif

	if (!as_SHInitDialog || !as_SHFullScreen || !as_SHDoneButton || !as_SHCreateMenuBar || !as_SHFindMenuBar ||
#if !(UNDER_CE < 0x400)
	    !as_SHHandleWMSettingChange || !as_SHHandleWMActivate ||
#endif
	    !as_SHInitExtraControls || !as_SHRecognizeGesture)
	{
		debug_level((DBG_FUNCTION, "aygshell_init - function NULL pointer!\n"));
	}
}

void aygshell_cleanup(void)
{
	debug_level((DBG_FUNCTION, "aygshell_cleanup();\n"));
	if (aygshell_module)
		FreeLibrary(aygshell_module);
}

#endif

