/*
 * wince_defs.c: default settings that are specific to wince.
 */

#include "putty.h"

FontSpec *platform_default_fontspec(const char *name)
{
	if (!strcmp(name, "Font"))
		return fontspec_new("Tahoma", 0, 8, DEFAULT_CHARSET);
	else
		return fontspec_new("", 0, 0, DEFAULT_CHARSET);
}

Filename *platform_default_filename(const char *name)
{
	if (!strcmp(name, "LogFileName"))
		return filename_from_str("putty.log");
	else
		return filename_from_str("");
}

char *platform_default_s(const char *name)
{
    if (!strcmp(name, "SerialLine"))
	return dupstr("COM1");
    return NULL;
}

int platform_default_i(const char *name, int def)
{
	return def;
}
