#include <windows.h>
#include "wince_device.h"

struct wince_dev_t wince_dev_list[] = {
	{
		WINCE_DEV_UNK,
		L"WINCE_DEV_UNK",
		L"UnknownPC",
		L"Unknown Device",
		9,
		9,
		31337,
		0
	},
	{
		WINCE_DEV_EVC4EMU_PC2K3,
		L"WINCE_DEV_EVC4EMU_PC2K3",
		L"PocketPC",
		L"CEPC",
		4,
		20,
		1081,
		3
	},
	{
		WINCE_DEV_VS2K5EMU_PC2K3,
		L"WINCE_DEV_VS2K5EMU_PC2K3",
		L"PocketPC",
		L"Microsoft DeviceEmulator",
		4,
		21,
		1088,
		3
	},
		{
		WINCE_DEV_VS2K5EMU_SP2K3,
		L"WINCE_DEV_VS2K5EMU_SP2K3",
		L"SmartPhone",
		L"Microsoft DeviceEmulator",
		4,
		21,
		1088,
		3
	},
	{
		WINCE_DEV_VS2K5EMU_WM5,
		L"WINCE_DEV_VS2K5EMU_WM5",
		L"PocketPC",
		L"Microsoft DeviceEmulator",
		5,
		1,
		1700,
		3
	},
	{
		WINCE_DEV_FSPL720_PPC2K3SE,
		L"WINCE_DEV_FSPL720_PPC2K3SE",
		L"PocketPC",
		L"FUJITSU SIEMENS COMPUTERS Pocket LOOX 720",
		4,
		21,
		1088,
		3
	},
	{ WINCE_DEV_UNK, NULL, NULL, 0, 0, 0, 0 }
};

BOOL wince_oeminfo(wchar_t *oeminfo, int bufsize)
{
	return SystemParametersInfo(SPI_GETOEMINFO, bufsize, oeminfo, FALSE);
}

BOOL wince_platform(wchar_t *platform, int bufsize)
{
	return SystemParametersInfo(SPI_GETPLATFORMTYPE, bufsize, platform, FALSE);
}

int wince_dev_id(OSVERSIONINFO *osv)
{
	int ret;
	wchar_t pla[MAX_PATH], oem[MAX_PATH];
	struct wince_dev_t *wdl = wince_dev_list;
	
	if(osv == NULL)
		return 0;
	
	wince_platform(pla, MAX_PATH-1);
	wince_oeminfo(oem, MAX_PATH-1);
	
	ret = WINCE_DEV_UNK;
	
	for (; wdl->platform; wdl++) {
		if (!wcscmp(wdl->platform, pla) &&
			!wcscmp(wdl->oem, oem) &&
			wdl->major == osv->dwMajorVersion &&
			wdl->minor == osv->dwMinorVersion) {
			ret = wdl->wince_dev;
			break;
		}
	}
	
	return ret;
}

struct wince_dev_t *wince_dev(int dev)
{
	struct wince_dev_t *wdl = wince_dev_list;
	
	for (; wdl->platform; wdl++) {
		if (wdl->wince_dev == dev)
			return wdl;
	}
	
	return NULL;
}